Forum.WEB/Controllers/DiscussionController.cs
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Forum.BLL.DTO;
using Forum.DAL.Entities;
using Microsoft.AspNetCore.Identity;
using Forum.WEB.ViewModel;
using AutoMapper;
using Forum.BLL.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;

namespace Forum.WEB.Controllers
{
    /// <summary>
    ///     Controller that performs display of all discussion of topic
    /// </summary>
    public class DiscussionController : Controller
    {
        private readonly IDiscussionService _discussionService;
        private readonly IMapper _mapper;
        private readonly UserManager<User> _userManager;
        private readonly ICommentService _commentService;


        /// <summary>
        ///     Method that creates the discussion controller (add discussion and view all discussions)
        /// </summary>
        /// <param name="mapper">
        ///     Mapper to create projections of one model in other model
        /// </param>
        /// <param name="discussionService">
        ///     Interface for working with discussion in the database indirectly
        /// </param>
        /// <param name="userManager">
        ///     User manager to manage them
        /// </param>
        /// <param name="commentService">
        ///     Interface for working with comment in the database indirectly
        /// </param>
        public DiscussionController(
            IMapper mapper,
            IDiscussionService discussionService,
            UserManager<User> userManager,
            ICommentService commentService)
        {
            _mapper = mapper;
            _discussionService = discussionService;
            _userManager = userManager;
            _commentService = commentService;
        }

        /// <summary>
        ///     Method that renders page with discussion and comments
        /// </summary>
        /// <param name="DiscussionId">
        ///     Id discussion with we wand commented or read
        /// </param>
        /// <returns>
        ///     Page with discussion and comments
        /// </returns>
        [HttpGet]
        public async Task<IActionResult> Index(string DiscussionId)
        {
            DiscussionViewModel discussionViewModel = 
                _mapper.Map<DiscussionViewModel>(_discussionService.GetAsync(Convert.ToInt32(DiscussionId)).Result);

            discussionViewModel.Comments = 
                _mapper.Map<List<CommentViewModel>>(_commentService.GetAllCommentsByDiscussionIdAsync(Convert.ToInt32(DiscussionId)).Result);

            foreach (var i in discussionViewModel.Comments)
            {
                i.User = _mapper.Map<UserDTO>( await _userManager.FindByIdAsync(i.UserId));
                i.UserFullName = i.User.UserName;
            }

            return View(discussionViewModel);
        }

        /// <summary>
        ///     Method that create new discussion with userId
        /// </summary>
        /// <param name="topicId">
        ///     Topic id to relate to discussion
        /// </param>
        /// <param name="userName">
        ///     Id category from which we want to see topics 
        /// </param>
        /// <returns>
        ///     Page with one categoty and its themes
        /// </returns>
        //[HttpGet]
        //public IActionResult CreatDiscussion(string topicId, string userName)
        //{
        //    User FindUser = _userManager.FindByNameAsync(userName).Result;
        //    DiscussionViewModel discussion = new DiscussionViewModel() 
        //    {
        //        TopicId = Convert.ToInt32(topicId),
        //        DiscussionDate= DateTime.Now,
        //        IsDiscussed= true,
        //        UserFullName= FindUser.FirstName.ToString() + " " + FindUser.LastName.ToString(),
        //        UserId = FindUser.Id
        //    };
        //    return View(discussion);
        //}

        /// <summary>
        ///     Method that create new discussion with userId
        /// </summary>
        /// <param name="allParams">
        ///     Topic id to relate to discussion
        /// </param>
        /// <returns>
        ///     Page with one categoty and its themes
        /// </returns>
        [HttpGet]
        public IActionResult CreatDiscussion(AddDiscussionTopicViewModel discussionView)
        {
            string topicId = discussionView.TopicId;
            string userName = User.Identity.Name;

            User FindUser = _userManager.FindByNameAsync(userName).Result;
            DiscussionViewModel discussion = new DiscussionViewModel()
            {
                TopicId = Convert.ToInt32(topicId),
                DiscussionDate = DateTime.Now,
                IsDiscussed = true,
                UserFullName = FindUser.FirstName.ToString() + " " + FindUser.LastName.ToString(),
                UserId = FindUser.Id
            };
            return View(discussion);
        }

        /// <summary>
        ///     Method that process creat discussion for provided discussion data
        /// </summary>
        /// <param name="DiscussionModel">
        ///     Discussion data from form
        /// </param>
        /// <returns>
        ///     Main page with all discussion in this topic
        /// </returns>
        [HttpPost]
        public async Task<IActionResult> CreatDiscussion(DiscussionViewModel DiscussionModel)
        {
            var checkDiscussion = await _discussionService.GetAllAsync();
            if (checkDiscussion.Where(x => x.DiscussionMessage.ToLower() == DiscussionModel.DiscussionMessage.ToLower()).Count() > 0)
            {
                ModelState.AddModelError("", "Такое обсуждение уже есть");
                return View(DiscussionModel);
            }

            DiscussionDTO discussion = _mapper.Map<DiscussionDTO>(DiscussionModel);

            await _discussionService.CreateAsync(discussion);

            return RedirectToAction("Index", "Topic", new { topicId = discussion.TopicId });
        }

        /// <summary>
        ///     Method that process dell discussion for provided topic data
        /// </summary>
        /// <param name="discussionId">
        ///     Id discussion wich we wand delete
        /// </param>
        /// <param name="topicId">
        ///     Id topic to wich we retern after delete
        /// </param>
        /// <returns>
        ///     Main page with all discussion with one topic
        /// </returns>
        [HttpPost]
        public async Task<IActionResult> DeleteDiscussion(string discussionId, string topicId)
        {
            await _discussionService.Delete(Convert.ToInt32(discussionId));
            return RedirectToAction("Index", "Topic", new { topicId = topicId });
        }

        /// <summary>
        ///     Method that renders page with edit discussion fields
        /// </summary>
        /// <param name="discussionId">
        ///     Id discussion with we want edit
        /// </param>
        /// <returns>
        ///     Page with edit discussion fields
        /// </returns>
        [HttpGet]
        public async Task<IActionResult> EditDiscussion(string discussionId)
        {
            var tmp =  await _discussionService.GetAsync(Convert.ToInt32(discussionId));

            var DiscussionView = _mapper.Map<DiscussionViewModel>(tmp);
            DiscussionView.Id = tmp.Id;

            return View(DiscussionView);
        }


        /// <summary>
        ///     Method that process edit category for provided discussion data
        /// </summary>
        /// <param name="DiscussionModel">
        ///     Discussion data from form
        /// </param>
        /// <returns>
        ///     Main page with all discussion with one topic
        /// </returns>
        [HttpPost]
        public  async Task<IActionResult> EditDiscussion(DiscussionViewModel DiscussionModel)
        {
            var checkDiscussion = await _discussionService.GetAllAsync();
            if (checkDiscussion.Where(x => x.DiscussionMessage.ToLower() == DiscussionModel.DiscussionMessage.ToLower()).Count() > 0)
            {
                ModelState.AddModelError("", "Такое обсуждение уже есть");
                return View(DiscussionModel);
            }

            await _discussionService.Update(_mapper.Map<DiscussionDTO>(DiscussionModel));

            return RedirectToAction("Index", "Topic", new { topicId = DiscussionModel.TopicId });
        }

    }
}

Forum.WEB/Controllers/TopicController.cs
using AutoMapper;
using Forum.BLL.Interfaces;
using Microsoft.AspNetCore.Mvc;
using System.Threading.Tasks;
using Forum.WEB.ViewModel;
using Forum.BLL.DTO;
using System.Collections.Generic;
using System;
using System.Linq;

namespace Forum.WEB.Controllers
{
    /// <summary>
    ///     Controller that performs display of all topics and their discussions
    /// </summary>
    public class TopicController : Controller
    {
        private readonly IDiscussionTopicService _discussionTopicService;
        private readonly IDiscussionService _discussionService;
        private readonly IMapper _mapper;

        /// <summary>
        ///     Method that creates the ropic controller (add topic, add discussion to topic)
        /// </summary>
        /// <param name="mapper">
        ///     Mapper to create projections of one model in other model
        /// </param>
        /// <param name="discussionService">
        ///     Interface for working with discussion in the database indirectly
        /// </param>
        /// <param name="discussionTopicService">
        ///     Interface for working with topics in the database indirectly
        /// </param>
        public TopicController(
            IMapper mapper,
            IDiscussionService discussionService,
            IDiscussionTopicService discussionTopicService)
        {
            _mapper = mapper;
            _discussionService = discussionService;
            _discussionTopicService = discussionTopicService;
        }


        /// <summary>
        ///     Method that renders page with discussion on the chosen topic
        /// </summary>
        /// <param name="topicId">
        ///     Id topic where do we want to see all discussion
        /// </param>
        /// <returns>
        ///     Page with discussion on the chosen topic
        /// </returns>
        [HttpGet]
        public IActionResult Index(string topicId)
        {
            DiscussionTopicViewModel discussionTopic =
                _mapper.Map<DiscussionTopicViewModel>(_discussionTopicService.GetAsync(Convert.ToInt32(topicId)).Result);

            discussionTopic.Discussions = 
                _mapper.Map<List<DiscussionViewModel>>(_discussionService.GetAllDiscussionOfDiscussionTopicAsync(Convert.ToInt32(topicId)).Result);

            AddDiscussionTopicViewModel addDiscussionTopicView = new AddDiscussionTopicViewModel
            {
                discussionTopicViewModel = discussionTopic
            };

            return View(addDiscussionTopicView);
        }


        /// <summary>
        ///     Method that renders page with add new topic in the chosen category
        /// </summary>
        /// <param name="categoryId">
        ///     Id categoty where do we want to add topic
        /// </param>
        /// <returns>
        ///     Page with add new category fields
        /// </returns>
        [HttpGet]
        public IActionResult CreatTopic(string categoryId)
        {
            return View(new DiscussionTopicViewModel() {IdCategory = Convert.ToInt32(categoryId) });
        }

        /// <summary>
        ///     Method that process creat topic for provided topic data
        /// </summary>
        /// <param name="TopicModel">
        ///     Topic data from form
        /// </param>
        /// <returns>
        ///     Main page with all topics
        /// </returns>
        [HttpPost]
        public async Task<IActionResult> CreatTopic(DiscussionTopicViewModel TopicModel)
        {
            var checkTopic = await _discussionTopicService.GetAllAsync();
            if (checkTopic.Where(x => x.Topic.ToLower() == TopicModel.Topic.ToLower()).Count() > 0)
            {
                ModelState.AddModelError("", "Такая тема уже есть");
                return View(TopicModel);
            }

            DiscussionTopicDTO category = new DiscussionTopicDTO()
            {
                Topic = TopicModel.Topic,
                IdCategory = TopicModel.IdCategory
            };

            await _discussionTopicService.CreateAsync(category);

            return RedirectToAction("Index", "Category", new { categoryId = TopicModel.IdCategory.ToString()});
        }

        /// <summary>
        ///     Method that process dell topic for provided topic data
        /// </summary>
        /// <param name="topicId">
        ///     Id topic wich we wand delete
        /// </param>
        /// <param name="categoryId">
        ///     Id category to wich we retern after delete
        /// </param>
        /// <returns>
        ///     Main page with all topics
        /// </returns>
        [HttpPost]
        public async Task<IActionResult> DeleteTopic(string topicId, string categoryId)
        {
            await _discussionTopicService.Delete(Convert.ToInt32(topicId));
            return RedirectToAction("Index", "Category", new { categoryId = categoryId });
        }


        /// <summary>
        ///     Method that renders page with edit topic fields
        /// </summary>
        /// <returns>
        ///     Page with edit topic fields
        /// </returns>
        [HttpGet]
        public IActionResult EditTopic(string topicId)  
        {
            var tmp = _discussionTopicService.GetAsync(Convert.ToInt32(topicId)).Result;
            return View(_mapper.Map<DiscussionTopicViewModel>(tmp));
        }


        /// <summary>
        ///     Method that process edit category for provided topic data
        /// </summary>
        /// <param name="TopicModel">
        ///     Topic data from form
        /// </param>
        /// <returns>
        ///     Main page with all topic with one category
        /// </returns>
        [HttpPost]
        public async Task<IActionResult> EditTopic(DiscussionTopicViewModel TopicModel)
        {
            var checkRole = await _discussionTopicService.GetAllAsync();
            if (checkRole.Where(x => x.Topic.ToLower() == TopicModel.Topic.ToLower()).Count() > 0)
            {
                ModelState.AddModelError("", "Такая тема уже есть");
                return View(TopicModel);
            }

            await _discussionTopicService.Update(_mapper.Map<DiscussionTopicDTO>(TopicModel));

            return RedirectToAction("Index", "Category", new { categoryId = TopicModel.IdCategory });
        }
    }
}

Forum.WEB/Views/Topic/CreatTopic.cshtml
@model Forum.WEB.ViewModel.DiscussionTopicViewModel
@{
    ViewBag.Title = "Добавление Темы";
}
<h1>Добавить тему</h1>
<form asp-action="CreatTopic" asp-controller="Topic">
    <input type="hidden"  asp-for="IdCategory" value = "@Model.IdCategory"/>
    <div class="form-group">
        <label asp-for="@Model.Topic" class="control-label">Название категории</label>
        <input type="text" asp-for="@Model.Topic" class="form-control" />
    </div>
    <div class="form-group">
        <input type="submit" value="Сохранить" class="btn btn-outline-secondary" />
    </div>
</form>

Forum.WEB/Views/Topic/EditTopic.cshtml
@model Forum.WEB.ViewModel.DiscussionTopicViewModel
@{
    ViewBag.Title = "Редактирование Темы";
}
<h1>Редактирование темы</h1>
<form asp-action="EditTopic" asp-controller="Topic">
    <input type="hidden"  asp-for="IdCategory" value = "@Model.IdCategory"/>
    <input type="hidden"  asp-for="Id" value = "@Model.Id"/>
    <input type="hidden"  asp-for="DiscussionCategory" value = "@Model.DiscussionCategory"/>
    <input type="hidden"  asp-for="Discussions" value = "@Model.Discussions"/>
    <div class="form-group">
        <label asp-for="@Model.Topic" class="control-label">Название категории</label>
        <input type="text" asp-for="@Model.Topic" class="form-control" value="@Model.Topic" placeholder="@Model.Topic"/>
    </div>
    <div class="form-group">
        <input type="submit" value="Сохранить" class="btn btn-outline-secondary" />
    </div>
</form>

Forum.WEB/Views/Topic/Index.cshtml
@model Forum.WEB.ViewModel.AddDiscussionTopicViewModel
@{
    ViewData["Title"] = "Все обсуждение в теме";
}

<h2>@Model.discussionTopicViewModel.Topic</h2>
<table class="table">
    @foreach (var discussion in Model.discussionTopicViewModel.Discussions)
    {
        <tr>
            <div>
                <td>    
                    <form asp-action="Index" asp-controller="Discussion" method="get">
                            <input type="hidden" name="discussionId" value="@discussion.Id" />
                            <button type="submit" class="btn button">
                                <div>@discussion.UserFullName</div>
                                <div>@discussion.DiscussionMessage</div>
                            </button>       
                    </form>
                </td>
                @if (User.IsInRole("Admin") || User.IsInRole("Root"))
                {
                    <td>
                        <form asp-action="EditDiscussion" asp-controller="Discussion" method="get" >
                            <input type="hidden" name="discussionId" value="@discussion.Id" />
                            <button type="submit" class="btn btn-sm btn-success">
                                Редактировать
                            </button>
                        </form>

                        <form asp-action="DeleteDiscussion" asp-controller="Discussion" method="post" >
                            <input type="hidden" name="discussionId" value="@discussion.Id" />
                            <input type="hidden" name="topicId" value="@discussion.TopicId" />
                            <button type="submit" class="btn btn-sm btn-danger">
                                Удалить
                            </button>
                        </form>
                    </td>
                }
            </div>
        </tr>
    }
</table>

<footer>
@if (User.Identity.IsAuthenticated)
{
    <form asp-action="CreatDiscussion" asp-controller="Discussion" method="get">
        <input type="hidden"  asp-for="TopicId" value = "@Model.discussionTopicViewModel.Id"/>
@*        <input type="hidden"  asp-for="UserFullName" value = "@User.Identity.Name"/>*@
        <input type="submit" value="Добавить Обсужение" class="btn button" />
    </form>
}
</footer>